﻿// -*- C++ -*-
/*!
 * @file  marker.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "marker.h"
#include <iostream>

// Module specification
// <rtc-template block="module_spec">
static const char* marker_spec[] =
  {
    "implementation_id", "marker",
    "type_name",         "marker",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "rsdlab",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
marker::marker(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_ArucoPose3DIn("ArucoPose3D", m_ArucoPose3D),
    m_markerdataOut("markerdata", m_markerdata)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
marker::~marker()
{
}



RTC::ReturnCode_t marker::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("ArucoPose3D", m_ArucoPose3DIn);
  
  // Set OutPort buffer
  addOutPort("markerdata", m_markerdataOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t marker::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t marker::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t marker::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t marker::onExecute(RTC::UniqueId ec_id)
{
  if (m_ArucoPose3DIn.isNew())
    {
      m_ArucoPose3DIn.read();

      int length = m_ArucoPose3D.ids.length();

      if(length == 2)
	{
	  m_markerdata.data.length(8);

	  for(int i=0;i<2;i++)
	    {
	      if(m_ArucoPose3D.ids[i] == 0)
		{
		  m_markerdata.data[0] = m_ArucoPose3D.ids[i];
		  m_markerdata.data[1] = m_ArucoPose3D.translates[i].x;
		  m_markerdata.data[2] = m_ArucoPose3D.translates[i].y;
		  m_markerdata.data[3] = m_ArucoPose3D.translates[i].z;
		}

	      if(m_ArucoPose3D.ids[i] == 1)
		{
		  m_markerdata.data[4] = m_ArucoPose3D.ids[i];
		  m_markerdata.data[5] = m_ArucoPose3D.translates[i].x;
		  m_markerdata.data[6] = m_ArucoPose3D.translates[i].y;
		  m_markerdata.data[7] = m_ArucoPose3D.translates[i].z;
		}
	    }
	  
	  std::cout << "aruco [id] is " << m_markerdata.data[4] << std::endl;
	  std::cout << "aruco [x] is " << m_markerdata.data[5] << std::endl;
	  std::cout << "aruco [y] is " << m_markerdata.data[6] << std::endl;
	  std::cout << "aruco [z] is " << m_markerdata.data[7] << std::endl;
	  
	}
	  
      //デバッグ用
      // std::cout << "aruco ids length is " << length << std::endl;
      
      // std::cout << "aruco id[0] is " << m_ArucoPose3D.ids[0] << std::endl;
      
      // std::cout << "aruco data[x] is " << m_ArucoPose3D.translates[0].x << std::endl;
      // std::cout << "aruco data[y] is " << m_ArucoPose3D.translates[0].y << std::endl;
      // std::cout << "aruco data[z] is " << m_ArucoPose3D.translates[0].z << std::endl;

      // std::cout << "aruco id[1] is " << m_ArucoPose3D.ids[1] << std::endl;
      // std::cout << "aruco data[x] is " << m_ArucoPose3D.translates[1].x << std::endl;
      // std::cout << "aruco data[y] is " << m_ArucoPose3D.translates[1].y << std::endl;
      // std::cout << "aruco data[z] is " << m_ArucoPose3D.translates[1].z << std::endl;
     
    }
      
  m_markerdataOut.write();    
    
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t marker::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t marker::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void markerInit(RTC::Manager* manager)
  {
    coil::Properties profile(marker_spec);
    manager->registerFactory(profile,
                             RTC::Create<marker>,
                             RTC::Delete<marker>);
  }
  
};


